#ifndef EVENTLISTFILLER_H
#define EVENTLISTFILLER_H

#include <QObject>

#include "adcm_raw.h"
class QTime;
class QTimer;

class adcm_el_t;
class adcm_decstat_t;
class AdcmDataBlockDecoder;
class DecodeManager;
class conf_mem_t;


class EventListFiller : public QObject
{
    Q_OBJECT
public:
    explicit EventListFiller(adcm_el_t * const, DecodeManager * const decodeManager);
    ~EventListFiller();
    
signals:
    void completed(quint64);
    void progressChanged(double);
    void statisticsUpdated(const adcm_decstat_t &);
    void eventsProceedUpdated(quint64);
//    void requestWorkerStatistic();
    
public slots:
    void appendFrameList(const FrameList &r);
    void setAdcConfMem(const conf_mem_t &value);
    void clear();
    void reset();
    void sendStatistics();

private:
    void appendFrame(const QByteArray &buf);
    int decodeRawFrame(const unsigned int *frame, size_t flen);
    void updateProgress(bool force=false);

    struct adcm_el_t * const eventList;
    AdcmDataBlockDecoder * const adcmDataBlockDecoder;
    adcm_decstat_t * const fillerDecStat;
    DecodeManager * const manager;

    uint frameListSize; // for progress
    uint framesDecoded; // for progress
    QTime * const lastProgressTime;
    QTime * const workTime;
    QTimer * const statisticTimer;
};

#endif // EVENTLISTFILLER_H
