//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef SETUPDATAOUTPUTDIALOG_H
#define SETUPDATAOUTPUTDIALOG_H

#include "ui_SetupDataOutputDialogUi.h"
class StorageConfig;

class SetupDataOutputDialog : public QDialog, public Ui::SetupDataOutputDialogUi
{
    Q_OBJECT
public:
    explicit SetupDataOutputDialog(StorageConfig sets, int storageMode, bool runMode, QWidget *parent = 0);

//    QString getBaseDir() const { return basedir; }
//    QString getName() const { return name; }
//    bool getMode() const { return mode; }
//    QString getFileName() const { return filename; }
//    bool getRawEnable() const { return raw_enable; }
//    void setBaseDir( const QString &text ) { basedir = text; }
//    void setName( const QString &text ) { name = text; }
    void setMode( int value );
    void setFileName( const QString &text );
    void setRawEnable(bool rawEnable);
    bool updateStorageConfig(StorageConfig&) const;

protected:
    void update_mode();

signals:

public slots:

private slots:
    void on_radioButton_continuous_clicked();
    void on_radioButton_recycle_clicked();
    void on_spinBox_period_valueChanged(int arg1);
    void on_pushButton_Select_clicked();
    void on_groupBox_raw_toggled( bool );
    void update_filename();
    void update_raw_enable();

private:
    QString basedir;
    int mode;
    int period;
    QString filename;
    bool raw_enable;
    QString name;
    bool runControlInRunState;

};

#endif // SETUPDATAOUTPUTDIALOG_H
