//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <QPixmap>
#include <QLabel>

#include "StatusMessageBox.h"

StatusMessageBox::StatusMessageBox(QWidget *parent) :
    QDialog(parent)
{
    setupUi(this);
}


void StatusMessageBox::setPixmap( const QPixmap &p )
{
    pixmap->setPixmap(p);
}


void StatusMessageBox::setText( const QString & t)
{
    label->setText(t);
    adjustSize();
}


void StatusMessageBox::accept()
{
    QDialog::accept();
    emit accepted();
}

void StatusMessageBox::reject()
{
    QDialog::reject();
    emit rejected();
}
