//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <iostream>

#include <QRadioButton>

#include "adcm16.h"
#include "TrigSetupDialog.h"

TrigSetupDialog::TrigSetupDialog(QWidget *parent) :
    QDialog(parent)
{
    setupUi(this);
}

void TrigSetupDialog::setData( int data )
{
    radioButton_int_simple->setChecked(data & ADCM_TRIGBIT_INT_SIMPLE);
    radioButton_int->setChecked(data & ADCM_TRIGBIT_INT);
    radioButton_ext->setChecked(data & ADCM_TRIGBIT_EXT);
    radioButton_int_simple->setEnabled(false);
}

int TrigSetupDialog::getData() const
{
    int data = 0;
    if (radioButton_int_simple->isChecked()) data |= ADCM_TRIGBIT_INT_SIMPLE;
    if (radioButton_int->isChecked()) data |= ADCM_TRIGBIT_INT;
    if (radioButton_ext->isChecked()) data |= ADCM_TRIGBIT_EXT;
    return data;
}
