#ifndef HIST_H
#define HIST_H

#include <vector>
#include "ui_histdialogbase.h"
#include "histmanager.h"

class QTimer;

class HistDialog: public QDialog, public Ui::HistDialogBase
{
    Q_OBJECT

public:
    HistDialog (QWidget* parent, const th1Ptr h);
    virtual ~HistDialog();
    //    void set_h( const HistPtr fh );
    const th1Ptr get_h() const;
    void update();
    int getid() const;
    void setid( int id );
    QString getName() const;
    HistPlot * getplot() const;
    void get_fit_param( bool * ffitok, double * fvalue, double * fmean, double * fsigma, double * fnorm ) const;

protected:
    void update_bin_range();
    void update_controls();
    void save();
    void Restore();

public slots:
    void show();

private slots:
    void update_view();
    void on_pushButtonSave_clicked();

private:
    const th1Ptr h;
    int myid;
    QTimer *updatetimer;
    std::vector<double> px, pxf, py, pf;
    double value, mean, sigma, norm;
    int disable_slots;
    unsigned int alloc_nbins;
    int modseq;
    bool fit_ok;
};

#endif /* HIST_H */
