#ifndef _HPLOT_H
#define _HPLOT_H

#include <vector>
#include <qwt_plot.h>

class HistPlotPrivate;

class HistPlot:public QwtPlot
{
public:
    explicit HistPlot (QWidget * p = 0);
    ~HistPlot();
    void setpoints (const std::vector<double> &inx, const std::vector<double> &iny);
    void clear_points();
    void set_fit_points (const std::vector<double> &inx, const std::vector<double> &iny);
    void clear_fit_points();
    std::vector<double> getpointsx() const;
    std::vector<double> getpointsy() const;
    std::vector<double> getfitpointsx() const;
    std::vector<double> getfitpointsy() const;
    int getpointslen() const;
    int getfitpointslen() const;
    void set_x_range(double xmin, double xmax);

private:
    HistPlotPrivate * const d;
};

#endif /* _HPLOT_H */
