#ifndef SETTINGS_DATA_H
#define SETTINGS_DATA_H

#include <QVector>
#include "config/allconfig.h"

class SettingsDataStorage {
public:
    SettingsDataStorage();
    void print() const;

    unsigned int timestamp_is_utc;
    unsigned int trig_min; // Minimum channels in event
    unsigned int trig_max; // Muximum channels in event
    unsigned int samples_base;
    QVector<unsigned int> samples_mult; // number of samples = base*mult
    unsigned int flen_max;
    unsigned int fcnt_max;
    unsigned int ch_dpm_ks;
    AllConfig cfg;
};

class SettingsData {
public:
    SettingsData();
    SettingsData(const SettingsData &);
    SettingsData &operator=(const SettingsData &);
    void copyFromCfg(const AllConfig &);
    void copyToCfg(AllConfig *) const;

    SettingsDataStorage sds;

protected:
    void copyData(const SettingsData &);
};



#endif /* SETTINGS_DATA_H */
