//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef _ADCM_CHBUF_IMPL_H
#define _ADCM_CHBUF_IMPL_H 1

#include <vector>
#include <QtCore/QtGlobal>

typedef qint16 AdcmCbufSample;
typedef std::vector<AdcmCbufSample> AdcmCbufWaveform;

class adcm_chbuf_t
{
public:
    adcm_chbuf_t();
    //  void clear() { *this = adcm_chbuf_t(); }
    inline void clear() { flags=0; ch=0; ts=0; tp=0; b=0; i=0; dc=0; rms=0;pp=0; fasttime=0; fastnorm=0;
                          pt=0; pa=0; pw=0; pchi2=0; pniter=0; w_bits=0; w.clear(); }
    unsigned int flags;
    unsigned int ch; // channel number
    size_t len() const { return w.size(); }
    quint64 ts;
    // decoded parameters
    unsigned int tp;            // threshold position
    float b;                    // baseline
    float i;                    // not integral, but mean value of signal
    float dc;
    float rms;
    int pp;                     // peak index
    float fasttime;             // peak coarse time
    float fastnorm;             // coarse time fit norm
    float pt;                   // peak fine time
    float pa;                   // peak amplitude
    float pw;                   // peak width
    float pchi2;                // normalized by a and len
    int pniter;
    unsigned short w_bits;
    AdcmCbufWaveform w;
};

#endif /* _ADCM_CHBUF_IMPL_H */
