#ifndef ADCM_UTIL_H
#define ADCM_UTIL_H

#include <QtCore/QtGlobal>

#include "adcm_dws.h"
#include "config/calzeroconfig.h"

class FrameFinder;
class AdcmDataBlockDecoder;
class adcm_el_t;
class AdcmEvent;

class AdcmUtil
{
public:
    AdcmUtil();
    ~AdcmUtil();
    int decode_and_print(const char *buf, size_t data_size);

protected:
    void print_baseline_calibration (CalZeroConfig * cz);
    int handle_decoded_event (AdcmEvent * ev);
    void print_raw_decoded (const quint32 *buf, size_t start, size_t end);

private:
    AdcmUtil(const AdcmUtil &); // copy prohibited

    FrameFinder *frameFinder;
    AdcmDataBlockDecoder *adcmDataBlockDecoder;
    adcm_el_t *el;
    CalZeroConfig calzero;
    adcm_decstat_t decst;
    unsigned int ev_ind_prev;
    unsigned int dec_frame_err;
    unsigned int dec_frame_ok;
    unsigned int dec_blk_ok;
    unsigned int dec_nev_ok;
};

#endif /* ADCM_UTIL_H */
