#include <cstdio>
#include "qlog/ansi_col.h"
#include "bitop.h"

void bitcopy (unsigned char *dst, int doff, const unsigned char *src, int soff, int len)
{
    for (int i = 0; i < len; i++) {
        int is = i + soff;
        int id = i + doff;
        (src[is >> 3] & (1 << (is % 8))) ? (dst[id >> 3] |= (1 << (id % 8))) : (dst[id >> 3] &= (~(1 << (id % 8))));
    }
}

int bitcmp (const unsigned char *in, const unsigned char *out, int len)
{
    for (int j = 0; j < len; j++) {
        int bin = ((in[j >> 3]) >> (j % 8)) & 1;
        int bout = ((out[j >> 3]) >> (j % 8)) & 1;
        if (bin != bout)
            return (-1);
    }
    return 0;
}

void bitprintdiff (const unsigned char *in, const unsigned char *out, int len)
{
    //            printf("--- bit diff ---\n");
    for (int j = 0; j < len; j++) {
        int bin = ((in[j >> 3]) >> (j % 8)) & 1;
        int bout = ((out[j >> 3]) >> (j % 8)) & 1;
        if (bin == bout)
            printf ("%s", ANSI_NORM);
        else
            printf ("%s", ANSI_RED);
        printf ("%d", bout);
    }
    printf ("%s\n", ANSI_NORM);
}

void bitprint (const unsigned char *in, int len)
{
    //            printf("--- bit dump ---\n");
    for (int j = 0; j < len; j++) {
        int bin = ((in[j >> 3]) >> (j % 8)) & 1;
        printf ("%d", bin);
    }
    printf ("%s\n", ANSI_NORM);
}
