//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef STORAGECONFIG_H
#define STORAGECONFIG_H

#include "inibased.h"

enum {SET_DATAFILE_RAW, SET_DATAFILE_DEV};

class StorageConfig : public IniBased
{
public:
    StorageConfig();
    virtual ~StorageConfig() {}
    bool operator==(const StorageConfig &other) const;
    bool operator!=(const StorageConfig &other) const {return !operator==(other);}
    virtual void writeToIni(QSettings *settings, const QString &section = QString()) const;
    virtual void readFromIni(QSettings *settings, const QString &section = QString());
    virtual QString sectionName() const { return "storage"; }

    int enable;
    int mode;                //!< 0 = recycle, 1 = continuous
    int period;              //!< timer period in sec
    QString bn;              //!< base directory name
    QString fn;              //!< filename
    quint64 szlimit;         //!< file size limit
};

Q_DECLARE_METATYPE(StorageConfig)

#endif // STORAGECONFIG_H
