//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef ADCM_WS_T_H
#define ADCM_WS_T_H

#include "adcm16.h"
#include "dsplib/fir_types.h"
#include "dsplib/fitter.h"

const unsigned int WBMAXPRELOAD = (FIRMAXLEN/2);
const unsigned int WB_SIZE = WBMAXPRELOAD + ADCM_MAX_N_SAMP;
typedef short int wbc_sample_t;
struct wbc_t {
    int len;
    wbc_sample_t d[WB_SIZE];
};

typedef wbc_t wb_t[ADC_NCH];

#define CONVLEN (ADCM_MAX_N_SAMP + FIRMAXLEN)

struct cb_t {
    int len;                      // useful size, should be < CONVLEN
    int offs;                     // FIR offset
    int i1, i2;                   // peak search range
    int ip;                       // peak position
    double ap;                    // peak amplitude
    int d[CONVLEN];
};

struct fb_t {
    int len;                      // useful size, should be < CONVLEN
    int offs;                     // FIR offset
    double d[MAX_FITGAUS_POINTS];
};

struct adcm_ws_base
{
    wb_t wb;
    cb_t cb[ADC_NCH];
    fb_t fb[ADC_NCH];
};

class adcm_ws_t: public adcm_ws_base
{
public:
    adcm_ws_t() : adcm_ws_base() {}
};

#endif // ADCM_WS_T_H
