//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "genericdecoder.h"

#include "adcmraw/adcm_mem.h"
#include "config/adcconfig.h"
#include "config/decoderconfig.h"
#include "config/calavgconfig.h"
#include "config/calzeroconfig.h"

GenericDecoder::GenericDecoder(QObject *parent) :
    QObject(parent),
    conf_mem(new conf_mem_t),
    adc(new AdcConfig),
    dec(new DecoderConfig),
    calZero(new CalZeroConfig),
    calAvg(new CalAvgConfig)
{
}

GenericDecoder::~GenericDecoder()
{
    delete conf_mem;
    delete adc;
    delete dec;
    delete calAvg;
    delete calZero;
}

void GenericDecoder::setAdcConfMem(const conf_mem_t &confMem)
{
    *conf_mem = confMem;
}

void GenericDecoder::adcConfigModified(const AdcConfig &adcConfig)
{
    *adc = adcConfig;
}

void GenericDecoder::decoderConfigModified(const DecoderConfig &decoderConfig)
{
    *dec = decoderConfig;
}

void GenericDecoder::CalZeroConfigModified(const CalZeroConfig &calZeroConfig)
{
    *calZero = calZeroConfig;
}

void GenericDecoder::CalAvgConfigModified(const CalAvgConfig &calAvgConfig)
{
    *calAvg = calAvgConfig;
}
