#ifndef _FIR_TYPES_H
#define _FIR_TYPES_H

#include <QVector>
#include "config/inibased.h"

const int FIRFILE_MAGIC = 0x20524946;
const unsigned int FIRMAXLEN = 256;
const unsigned int FIRMAXHALF = (FIRMAXLEN/2+1);

class intfir_t : public IniBased
{
public:
    intfir_t() : klen(0), offs(0), bits(1), coef(FIRMAXLEN) {}
    bool operator==(const intfir_t &other) const {
        return true
                && klen == other.klen
                && offs == other.offs
                && bits == other.bits
                && coef == other.coef
                ;
    }
    virtual void writeToIni(QSettings *settings, const QString &section = QString()) const;
    virtual void readFromIni(QSettings *settings, const QString &section = QString());
    virtual QString sectionName() const { return "fir"; }

    unsigned int klen;
    unsigned int offs;
    unsigned int bits;
    QVector<int> coef;
};

class dblfir_t
{
public:
    dblfir_t() : klen(0), offs(0), coef(FIRMAXLEN) {}
    bool operator==(const dblfir_t &other) const {
        return true
                && klen == other.klen
                && offs == other.offs
                && coef == other.coef
                ;
    }
    unsigned int klen;
    int offs;
    QVector<double> coef;
};

#endif                          /* _FIR_TYPES_H */
