/*
 *
 * ADCM-16 hardware settings and registers definition
 *
 */

#ifndef ADCM16_H
#define ADCM16_H 1

const unsigned int ADCM_BOARD_NCH = 16;

const unsigned int ADCM_MIN_N_SAMP = 4;
const unsigned int ADCM_MAX_N_SAMP = 4096; /* hardware limit is 8192 */
const unsigned int ADCM_MIN_FRAGM_LEN = ADCM_MIN_N_SAMP;

const unsigned int ADCM_N_CH = 64; /* maximum number of channels in system */
const unsigned int ADC_NCH = ADCM_N_CH; // alias

const double ADC_REALSTEP = 10e-9;

//const double ADC_TS_FREQ = 1e8;         /* timestamp counter clock, Hz */

const unsigned int ADC_MAX_GAIN = 4095;
const unsigned int ADC_DEFAULT_GAIN = 700;
const unsigned int ADC_GAIN_0dB = 70;

const unsigned int ADCM_TRIGBIT_EXT = 0x01; /* hardware */
const unsigned int ADCM_TRIGBIT_INT_SIMPLE = 0x0200;
//const unsigned int ADCM_TRIGBIT_EXT2 = 0x02;
//const unsigned int ADCM_TRIGBIT_EXT3 = 0x04;
const unsigned int ADCM_TRIGBIT_INT = 0x0800;

const unsigned int ADCM_CCTRL_BIT_CMPEN = 0x0001;
const unsigned int ADCM_CCTRL_BIT_S     = 0x0002;
const unsigned int ADCM_CCTRL_BIT_M     = 0x0004;
const unsigned int ADCM_CCTRL_BIT_TEST  = 0x0008;
const unsigned int ADCM_CCTRL_BIT_ZERO  = 0x0010;
const unsigned int ADCM_CCTRL_BIT_INV   = 0x0020;

#endif /* ADCM16_H */
