#ifndef ADCM_DF_H
#define ADCM_DF_H 1

#include <QtCore/QtGlobal>
#include <QtCore/QVector>

#include "adcm16.h"

const quint16 STOR_ID_CMAP = 0x504D;    /* 'MP' */
const quint16 STOR_ID_EVNT  = 0x5645;    /* 'EV' */
const quint16 STOR_ID_CNTR  = 0x5443;    /* 'CT' */

#pragma pack(push, 1)
struct stor_packet_hdr_t {
  quint16 id;                 // data block ID
  quint16 size;               // block size, bytes
};

struct stor_ev_hdr_t {
  quint8 np;                  // number of pulses following
  quint8 reserved1;
  quint16 reserved2;
  quint32 ts;                 // timestamp, 10 ns step
};

struct stor_puls_t {
  quint8 ch;
  quint8 flags;
  float a; // Mean value relatively baseline
  float t; // Peak time, ns
  float w; // Peak width, ns
};

struct adcm_cmap_t {
  quint32 n;
  quint8 map[ADC_NCH];
};

struct adcm_counters_t {
    adcm_counters_t() {clear();}
    void clear() {n=0; time = 0; for(unsigned int i=0; i<ADC_NCH; i++) rawhits[i] = 0;}
    quint32 n;
    double time;
    quint32 rawhits[ADC_NCH];
};
#pragma pack(pop)

/*
class AdcHitCounters
{
public:
    AdcHitCounters() : time(0) {}
    double time;
    QVector<quint32> rawhits;
};
*/

#endif /* ADCM_DF_H */
