
#include <map>

#include <QtGlobal>

#include "regio/regiobase.h"
#include "jtag_impl.h"

namespace mlink {

    class Jtag_Impl_CCBPCIe : public Jtag_Impl
    {
    public:
        explicit Jtag_Impl_CCBPCIe(RegIOBase &r, int destAddress)
            : Jtag_Impl(destAddress), link(r) { clearStats(); }
        virtual ~Jtag_Impl_CCBPCIe();
        virtual bool jtag_io (bool tms, bool tdi);
        virtual std::vector<bool> jtag_io_b(const std::vector<bool> &btms, const std::vector<bool> &btdi);
        virtual void jtag_io_b32_blk (unsigned int count, const unsigned int *tdi32Data, unsigned int *tdo32Data);
        void clearStats();
        void printStats() const;

    protected:
        RegIoPacket packetIo(const RegIoPacket &sendPkt);

        RegIOBase &link;
        quint64 count_pkt;
        quint64 count_io;
        std::map<size_t, quint64> count_io_b;
        std::map<size_t, quint64> count_io_b32;
    };

};
