#ifndef MLINK_JTAG_STATE_H
#define MLINK_JTAG_STATE_H

#include <iosfwd>

namespace mlink {

    //  JTAG state machine states

    typedef enum {
        JS_TEST_LOGIC_RESET = 0,      // RESET -- stable state
        JS_RUN_TEST_IDLE,             // IDLE -- stable state
        JS_SELECT_DR_SCAN,
        JS_CAPTURE_DR,
        JS_SHIFT_DR,
        JS_EXIT1_DR,
        JS_PAUSE_DR,                  // DRPAUSE -- stable state
        JS_EXIT2_DR,
        JS_UPDATE_DR,
        JS_SELECT_IR_SCAN,
        JS_CAPTURE_IR,
        JS_SHIFT_IR,
        JS_EXIT1_IR,
        JS_PAUSE_IR,                  // IRPAUSE -- stable state
        JS_EXIT2_IR,
        JS_UPDATE_IR,

        JTAG_STATE_COUNT
    } JTAG_STATE;

    extern const char *jtagStateMap[JTAG_STATE_COUNT];
    const char *jtagStateStr(JTAG_STATE state);

    extern JTAG_STATE jtag_next_state[JTAG_STATE_COUNT][2];

    std::ostream& operator<< (std::ostream & os, const JTAG_STATE &r);

};

#endif /* MLINK_JTAG_STATE_H */
