#ifndef DEVICEEMU_H
#define DEVICEEMU_H

#include <QMap>
#include "regio/regiopacket.h"
#include <QtGlobal>

namespace mlink {

    class DeviceEmu {
    public:
        DeviceEmu();
        virtual ~DeviceEmu();
        virtual void reset();
        void putPacket(const RegIoPacket&p) { rxBuf.push_back(p); }
        virtual void processPackets();
        PacketList getPackets() { PacketList tmp(txBuf); txBuf.clear(); return tmp; }
        bool isPPAddressEnabled() const;

    protected:
        virtual void writeReg(int addr, int data);
        virtual int readReg(int addr) const;
        virtual std::vector<quint32> readRam(unsigned int startAddr, unsigned int blockSize) const;
        virtual void writeRam(int startAddr, const std::vector<quint32> &data);

        PacketList txBuf, rxBuf;
        unsigned short txSeq;
        QMap<quint32, quint16> regs16;
        QMap<quint32, quint16> regs16ReadOnly; // not cleared on reset()
        std::vector<quint32> ram32;
    };

} // namespace mlink

#endif // DEVICEEMU_H
