//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef QXW_WAVEFORMVIEWADVANCED_P_H
#define QXW_WAVEFORMVIEWADVANCED_P_H

#include <vector>
#include "dsplib/fir_types.h"
#include "qxw/WaveformAverager.h"
#include "qxw/WaveformFilter.h"
#include "qxw/WaveformViewAdvanced.h"

class WaveformModel;

class WaveformViewAdvancedPrivate
{
public:
    WaveformViewAdvancedPrivate();
    virtual ~WaveformViewAdvancedPrivate();
    WaveformModel *model;
    WaveformAverager averager;
    WFChannelMap chmap;
    bool offsetComp;
    bool selectFilter;
    bool enableAverager;
    bool enableFFT;
    std::map<int, intfir_t> filter;
    std::map<int, double> fullScale;
    WaveformFilterFFT waveformFilterFFT;
    WaveformFilterFIR waveformFilterFIR;
};

#endif // QXW_WAVEFORMVIEWADVANCED_P_H
